/* Based on DHTServer, ESP8266Webserver, DHTexample, and BlinkWithoutDelay
   ECE 4760: Vaidehi Garg (vg254), Divya Gupta (dg524), Vidya Ramesh (vr236)
*/

#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>

const char* ssid     = "PutSSIDHere";
const char* password = "***********";

ESP8266WebServer server(80);

// String to display
String webString;
String readString;

// Variables that store time are stored in unsigned longs
unsigned long previousMillis = 0;        // will store last temp was read
const long interval = 2000;              // interval at which to read sensor
 
void handle_root() {
  server.send(200, "text/plain", "Welcome to ECE4760 Borkbit, read from /temp");
  delay(100);
}

char buf[256];

void getSerial() {
  int i = 0;
  while (Serial.available() > 0 && i < 256) {
    char val = Serial.read(); //get one byte from serial buffer
    readString += val;        //append byte to readString
    buf[i] = val;
    delay(2);
    i++;
  }

  if (readString.length() > 0) {
    Serial.println(buf);
    readString = "";
  }
}
 
void setup(void)
{
  Serial.begin(9600);

  // Connect to WiFi network
  WiFi.begin(ssid, password);
  Serial.print("Connecting to wifi...");

  // Wait for connection
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  
  Serial.println("");
  Serial.println("ECE 4760 Borkbit Server");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
   
  server.on("/", handle_root);
  
  server.on("/temp", [](){
    getSerial();
    webString = (String) buf;
    server.send(200, "text/plain", webString);  // send to browser when asked
    memset(buf, 0, sizeof buf);
  });
  
  server.begin();
  Serial.println("HTTP server started");
}
 
void loop(void)
{
  server.handleClient();
}
